{*****************************************************************************}
{*                                                                           *}
{*                       SoftWeyr Trash can for Windows                      *}
{*                          Version 1.0                                      *}
{*                       Copyright (c) by SoftWeyr,1995                      *}
{*                                                                           *}
{*****************************************************************************}



uses  objects,Strings,
      WinTypes,WinProcs,Win31,
      WinDos,
      OWindows,ODialogs,
      shellapi;
Type PMainWindow=^TMainWindow;
     TMainWindow=object(TWindow)
                   Constructor Init(Aparent:PWindowsObject;Atitle:PChar);
                   Function GetClassName:PChar;virtual;
                   Procedure SetupWindow;virtual;
                   Procedure GetWindowClass(var AWndClass:TWndClass);virtual;
                   Procedure WMQueryOpen(var Msg:TMessage);virtual wm_First+wm_QueryOpen;
                   Procedure WMDropFiles(var Msg:TMessage);virtual wm_First+ wm_DropFiles;
                   Procedure WMSysCommand(var Msg:TMessage);virtual wm_First+wm_SysCommand;
                   Procedure recordPosition;
                   Function CanClose:boolean;virtual;
                   Procedure ShowWinFile;
                  end;
       PMyDialog=^TMyDialog;
       TMyDialog=object(TDialog)
                  Procedure Yes(var Msg:TMessage);virtual id_First+id_Yes;
                  Procedure EnterYes(var Msg:TMessage);virtual cm_First+id_Yes;
                 end;
       TFilename = array[0..255] of Char;
    TTrash=object(TApplication)
              First:Boolean;
              Procedure InitMainWindow;virtual;
              Procedure InitApplication;virtual;
              Procedure InitInstance;virtual;
            end;
{$R TRASH.RES}
Procedure TMyDialog.Yes(var Msg:TMessage);
begin
 if CanClose then EndDlg(idYes);
end;
Procedure TMyDialog.EnterYes(var Msg:TMessage);
begin
 Yes(Msg);
end;
Procedure TMainWindow.ShowWinFile;
var W:hWnd;
begin
 W:=FindWindow('WFS_Frame',nil);
 if W=0 then
  {File manager not loaded}
  WinExec('WINFILE.EXE',sw_Show)
 else
 begin
  if IsIconic(W) then PostMessage(W,WM_SYSCOMMAND,SC_RESTORE,0) else
  PostMessage(W,WM_ACTIVATE,Word(True),Longint(W))
 end;
end;
procedure TMainWindow.RecordPosition;
var XStr,YStr:Array[0..12] of char;
    WPlace:TWindowPlaceMent;
begin
 With WPlace do
  begin
   Length:=SizeOf(WPlace);
   Flags:=WPF_SetMinPosition;
  end;
 GetWindowPlacement (hWindow,@WPlace);
 With WPlace.ptMinPosition do
  begin
   Str(Y,YStr);
   Str(X,XStr);
  end;
 if not WritePrivateProfileString('Position','X',XStr,'TRASH.INI') or
 not WritePrivateProfileString('Position','Y',YStr,'TRASH.INI') then
  MessageBox(hWindow,'Error saving position','Trash',mb_Ok+mb_iconExclamation);
end;
procedure TMainWindow.SetupWindow;
Var SysMenu:hMenu;Pos:TPoint;
    WPlace:TWindowPlacement;
begin
  inherited SetupWindow;
  Pos.X:=GetPrivateProfileInt('Position','X',600,'TRASH.INI');
  Pos.Y:=GetPrivateProfileInt('Position','Y',440,'TRASH.INI');
  DragAcceptFiles(HWindow, True);
  FillChar(WPlace,SizeOf(WPlace),0);
  WPlace.Length:=SizeOf(WPlace);
  WPlace.Flags:=WPF_SetMinPosition;
  WPlace.ShowCmd:=sw_ShowMinimized;
  WPlace.ptMinPosition:=Pos;
  WPlace.ptMaxPosition:=Pos;
  SetWindowPlacement(hWindow,@WPlace);
  SetWindowPos(hWindow,hwnd_Topmost,
  Pos.X,Pos.Y,0,0,SWP_NOACTIVATE+SWP_NOSIZE+SWP_ShowWindow);
  SysMenu:=GetSystemMenu(hWindow,False);
  RemoveMenu(SysMenu,4,mf_ByPosition);
  RemoveMenu(SysMenu,3,mf_ByPosition);
  RemoveMenu(SysMenu,0,mf_byPosition);
  RemoveMenu(SysMenu,1,mf_byPosition);
  RemoveMenu(SysMenu,1,mf_byPosition);
  RemoveMenu(SysMenu,2,mf_byPosition);
  AppendMenu(SysMenu,mf_Separator,0,nil);
  AppendMenu(SysMenu,mf_String,1024,'&Empty Trash');
  AppendMenu(SysMenu,mf_String,1025,'&About...');
  AppendMenu(SysMenu,mf_String,2048,'&File manager');
end;
Constructor TMainWindow.Init(Aparent:PWindowsObject;Atitle:PChar);
begin
 inherited Init(AParent,ATitle);
 Attr.Style:=Attr.Style or ws_Iconic;
end;
Function TMAinWindow.GetClassName:PChar;
begin
 GetClassName:='Trash_ttt'
end;
Procedure TMAinWindow.GetWindowClass(var AWndClass:TWndClass);
begin
 inherited GetWindowClass(AWndClass);
 AWndClass.hIcon:=LoadIcon(hInstance,'ICON_1');
end;
procedure TMainWindow.WMQueryOpen(var Msg: TMessage);
begin
 Msg.Result:=0;
end;
procedure TMainWindow.WMSysCommand(var Msg:TMessage);
Var AboutMsg:Array[0..255] of char;
    D:PDialog;
begin
 if Msg.wParam=1025 then
 begin
  D:=New(PDialog,Init(@Self,'DIALOG_3'));
  Application^.ExecDialog(D);
 end
 else
 if Msg.wParam=1024 then MessageBox(hWindow,
'This command is not allowed in freeware version. If you want to obtain full version of Trash, pay $799 and buy a Macintosh!',
 'Trash',mb_Ok+mb_IconHand)
 else
 if Msg.wParam=2048 then
  ShowWinFile else
 begin
 inherited WMSysCommand(Msg);
 end;
end;

Function TMainWindow.CanClose:Boolean;
begin
 RecordPosition;
 CanClose:=inherited CanClose;
end;
procedure TMainWindow.WMDropFiles(var Msg: TMessage);
var
  DropPt     : TPoint;
  hDrop      : THandle;
  NumDropped : Integer;
  DroppedName: TFilename;
  PName       :PChar;
  Mask:TFileName;
  I          : Integer;
  D:PDialog;
  QuerySubDir,QueryReadOnly:Boolean;
  Data:record
         Files:Integer;
         Dirs:Integer;
       end;
  Line:array[0..128] of char;
  P:PWindowsObject;
  S:String;
const  StdMsg='Are you sure to delete ';
function Query1Dir(Name:PChar):Boolean;
var Line:TFileName;
Cmd:Word;
begin
 D:=New(PMyDiaLOG,Init(@Self,'DIALOG_1' ));
 P:=New(PStatic,InitResource(D,11,128));
 D^.TransferBuffer:=@Line;
 wvsprintf(Line,'Directory %s is not empty. Delete anyway?',Name);
 Cmd:=Application^.ExecDialog(D);
 if Cmd=idYes then QuerySubDir:=false;
 Query1Dir:=(Cmd=idOk)or(cmd=idYes);
end;
function Query1Protected(Name:PChar):Boolean;
var Line:TFileName;
Cmd:Word;
begin
 D:=New(PMyDiaLOG,Init(@Self,'DIALOG_1' ));
 P:=New(PStatic,InitResource(D,11,128));
 D^.TransferBuffer:=@Line;
 Name:=@Name;
 wvsprintf(Line,'File %s is readonly. Delete anyway?',Name);
 Cmd:=Application^.ExecDialog(D);
 if Cmd=idYes then QueryReadOnly:=false;
 Query1Protected:=(Cmd=idOk)or(cmd=idYes);
end;
  Function IsDir(Name:PChar):Boolean;
  var S:TSearchRec;
  begin
   FindFirst(Name,faAnyFile,S);
   IsDir:=S.Attr and faDirectory<>0;
  end;
  Procedure DeleteFile(Name:PChar);
  var S:TSearchRec;
      Mask,Tmp:TFileName;
      F:File;
  begin
    FindFirst(Name,faAnyFile,S);
    if S.Attr and faDirectory<>0 then
     begin
      RemoveDir(Name);
      if DosError<>0 then
       if not QuerySubDir or Query1Dir(Name)then
        begin
         StrCopy(Mask,Name);
         StrCat(Mask,'\*.*');
         FindFirst(Mask,faAnyFile,S);
         While DosError=0 do
         begin
         if S.Name[0]<>'.' then
          begin
           StrCopy(Tmp,Name);
           StrCat(Tmp,'\');
           StrCat(Tmp,S.Name);
           DeleteFile(tmp)
          end;
          FindNext(S);
        end;
        RemoveDir(Name);
       end
      end
    else
    begin
     Assign(F,Name);
     if S.Attr and faReadOnly<>0 then
      if not QueryReadonly or Query1Protected(Name) then
        SetFAttr(F,0) else exit;
     Erase(F);
    end;
  end;
begin
  hDrop := Msg.WParam;
  QueryReadOnly:=True;
  QuerySubDir:=True;
  NumDropped := DragQueryFile(hDrop, Word(-1), nil, 0);
  If NumDropped=1 then D:=New(PMyDiaLOG,Init(@Self,'DIALOG_2' ))
     else D:=New(PMyDiaLOG,Init(@Self,'DIALOG_1' ));
 P:=New(PStatic,InitResource(D,11,128));
 data.Files:=numDropped;
 data.Dirs:=28;

 if NumDropped=1 then
  begin
   DragQueryFile(hDrop,0,@DroppedName,255);
   PName:=@DroppedName;
   if IsDir(DroppedName) then S:=StdMsg+'subdirectory' else
    s:=stdMsg+'file';
  wvsprintf(Line,StrPCopy(Mask,S+' %s'),PName);
 end else
 begin
  Data.Files:=0;
  Data.Dirs:=0;
  for I := 0 to NumDropped-1 do
  begin
    DragQueryFile(hDrop, I, DroppedName, SizeOf(DroppedName));
    if isDir(DroppedName) then inc(Data.Dirs) else inc(Data.Files);
  end;
 S:=stdMsg;
 if Data.Files<>0 then
  begin
   s:=s+' %d files';
   if data.Dirs<>0 then s:=S+' and '
  end
  else Data.Files:=Data.Dirs;
 if Data.Dirs<>0 then S:=s+' %d subdirectories ';
  wvsprintf(Line,StrPCopy(Mask,S) ,Data);
 end;
 D^.TransferBuffer:=@Line;
 i:=D^.Transfer(D^.TransferBuffer,tf_sizedata);
 Case Application^.ExecDialog(D) of
  idOk:{Yes} QuerySubDir:=NumDropped>0;
  idYes:{Yes to All} QuerySubDir:=False;
  else
   DragFinish(hDrop);
   exit;
  end;

  for I := 0 to NumDropped-1 do
  begin
    DragQueryFile(hDrop, I, DroppedName, SizeOf(DroppedName));
    DeleteFile(DroppedName);
  end;

  DragFinish(hDrop);
end;

Procedure  TTrash.InitMainWindow;
begin
 MainWindow:=New(PMainWindow,Init(nil,'Trash'));
end;
Procedure TTrash.InitApplication;
begin
 Inherited InitApplication;
 First:=True;
end;
Procedure TTrash. InitInstance;
var hOldTrash:hWnd;
begin
 if First then Inherited InitInstance
 else
  begin
    hOldTrash:=FindWindow(nil,'Trash');
    if hOldTrash<>0 then
      PostMessage(hOldTrash,WM_ACTIVATE,Word(True),Longint(hOldTrash));
    Halt(1);
  end
end;
var Trash:TTrash;
begin
 Trash.Init('Trash');
 Trash.Run;
 Trash.Done;
end.